program NkV;

uses NTypes, NLib, NDict, NConf, NForm, NCommand, Default, MainForm, FileList;

{$R *.RES}

var
  buf: string = '';
  i: Integer;
  keymap: TConf;
  keys: TStringArray = nil;
  list: TFileList;
  stdin: Boolean;
  path: string;
begin
  ProfDir := GetEnv('NKTOOLSPROF');
  if ProfDir = '' then
    ProfDir := DirName(ProgPath)
  else
    ProfDir := JoinPath([ProfDir, 'nkv']);
  
  Config := TConf.Create;
  Config['w'] := StringArray(['320']);
  Config['h'] := StringArray(['240']);
  Config.LoadFromFile(JoinPath([ProfDir, 'position']));
  Config.LoadFromFile(JoinPath([ProfDir, 'config']));

  if Config.GetBool('remote') and (Length(Argv) > 1) then
  begin
    for i := 1 to High(Argv) do
      buf := buf + '"' + AbsPath(Argv[i]) + '" ';
    try
      SendToRemoteForm(TNkVMainForm, buf);
      Exit;
    except
      on E: EOSError do ;
    end;
  end;

  keymap := TConf.Create;
  keymap.Read(Default.KeyMap);
  keymap.LoadFromFile(JoinPath([ProfDir, 'keymap']));

  App.Name := 'NkV';
  App.MainForm := TNkVMainForm.Create;
  Command := TCommand.Create(App.MainForm);
  Command.BindKeys(keymap);
  keymap.Free;
  App.Accel := Command.AccelHandle;
  with App.MainForm as TNkVMainForm do
  begin
    list := TFileList.Create;
    for i := 1 to High(Argv) do
    begin
      path := AbsPath(Argv[i]);
      if IsDir(path) then
      begin
        DirMode := High(Argv) = 1;
        list.AddDir(path);
      end else
        list.Add(path);
    end;
    list.Sort;
    stdin := list.Count = 0;
    if stdin then 
      list.Add('');
    LoadFirstFile(list);
    list.Free;

    if not stdin then
      if FileList.Count = 0 then
      begin
        ExitCode := 1;
        Exit;
      end
      else if FileList.Count = 1 then
      begin
        DirMode := True;
        FileListUpdate := True;
      end;
    Show;
  end;
  ExitCode := App.Run;

  Command.Free;
  App.MainForm.Free;
  Config.Free;
end.
